#include "xsnmp.h"

#define Debug	(Flags & (PROG_DEBUG_DNS | PROG_DEBUG))

char	answer[PACKETSZ];

/*
 * Print out a nameserver name field
 */
char *printname(buf, cp, pkt, fillchar, max)
char		**buf, *cp, *pkt, fillchar;
int		max; {
    register int	i;

    while(*cp > 0 && max > 0) {
	for(i = *cp++ , max-- ; i > 0 && max > 0 ; i-- , cp++ , (*buf)++) {
	    **buf = *cp;
	    max--;
	}
	if(max > 0 && *cp > 0)
	    *(*buf)++ = fillchar;
    }
    return ++cp;
}

/*
 * Skip over a name field
 */
char *skipname(cp) char *cp; {
    register int	i;

    if(*cp & 0xc0) cp += 2;
    else {
	while(*cp > 0)
	    for(i = *cp++ ; i > 0 ; i-- , cp++) ;
    }

    return cp;
}

short getshort(cp) char *cp; {
    union {
	short	t_num;
	char	t_char[2];
    }		type;

    type.t_char[0] = *cp++;
    type.t_char[1] = *cp++;
    return(ntohs(type.t_num));
}

short rrectype(cp) char *cp; {

    cp = skipname(cp);
    return(getshort(cp));
}

char *skiprec(cp) char *cp; {

    cp = skipname(cp);
    cp += 2 + 2;		/* skip over type and class fields */
    cp += 4;			/* skip over ttl field */
    cp += 2 + getshort(cp);	/* skip over data size and data fields */

    return(cp);
}

printdata(buf, cp, pkt) char **buf, *cp, *pkt; {
    register int	size;

    cp = skipname(cp);
    /* skip over the answer type and class fields */
    cp += 2 + 2;
    /* skip over the answer ttl field */
    cp += 4;
    /* skip over the data length field */
    size = getshort(cp);
    cp += 2;
    /* Now (FINALLY!) we have what we're looking for! */
    printname(buf, cp, pkt, ' ', size);
}

void xt_hinfo() {
    HOSTENTRY	*hostptr;
    char	packet[PACKETSZ];
    int		n, i;
    char	*hptr;
    HEADER	*hp;
    char	*rp;
    char	buffer[200];
    char	*bufptr;

    /* Get the HINFO record for this system */
    if((hostptr = widgettohost(Hostwidget)) == (HOSTENTRY *)NULL) {
	return;
    }

    hptr = fullhostname(hostptr->hl_name);

    n = res_mkquery(QUERY, hptr, C_IN, T_HINFO
		    , (char *)0, 0, NULL, packet, sizeof(packet));
    n = res_send(packet, n, answer, sizeof(answer));
    hp = (HEADER *)answer;
    rp = &answer[sizeof(HEADER)];

    /* skip over the question name field */
    bufptr = buffer;
    rp = printname(&bufptr, rp, answer, '.', PACKETSZ);
    *bufptr++ = ':'; *bufptr++ = ' ';

    /* skip over the question type and class fields */
    rp += 2 + 2;

    n = FALSE;
    for(i = 0 ; i < ntohs(hp->ancount) && !n ; i++)
	if(rrectype(rp) == T_HINFO) {
	    printdata(&bufptr, rp, answer);
	    n = TRUE;
	} else rp = skiprec(rp);

    if(n == FALSE)
	strcpy(bufptr, "No HINFO records registered");
    else {
	*bufptr++ = '\n';
	*bufptr = '\0';
    }

    disptext("DNS Hinfo Record", buffer); /* assumed to be null terminated */
}
