#include <sys/ioctl.h>
#include "xsnmp.h"

#define Debug	(Flags & (PROG_DEBUG_SNMP | PROG_DEBUG))

/*
 *	Author: J. Davin
 *	Copyright 1988, 1989, Massachusetts Institute of Technology
 *	See permission and disclaimer notice in file "notice.h"
 */

#include        <sys/types.h>

#include	<host.h>

#include	<ctypes.h>
#include	<rdx.h>
#include	<debug.h>
#include	<smp.h>
#include	<aps.h>
#include	<ap0.h>
#include	<asn.h>
#include	<smx.h>
#include	<udp.h>

#define		cmdBufferSize		(2048)
#define		cmdBindListSize		(20)
#define		cmdTextSize		(512)

SNMPIDSTR		*Snmpidstr;
int			(*Storeroutine)();
SNMPIDSTR		*Snmpids=(SNMPIDSTR *)NULL;

static	void	cmdInit ()

{
    aslInit ();
    asnInit ();
    apsInit ();
    ap0Init ();
    smpInit ();
}

static  SmpStatusType   myUpCall (smp, req)
SmpIdType               smp;
SmpRequestPtrType       req;
{
    SmpIndexType		i;
    SmpBindPtrType		bind;
    SmpBindPtrType		orig;
    CCharType		text [ (cmdTextSize + 1) ];
    int			cmp;
    
    if (req->smpRequestCmd != smpCommandRsp) {
	return (errOk);
    }
    
/*    printf ("Request Id: %d\n", req->smpRequestId);
/*    printf ("Error: %s\n", smxErrorToText (req->smpRequestError));
/*    printf ("Index: %d\n", req->smpRequestIndex);
/*    printf ("Count: %d\n", req->smpRequestCount);
/*    printf ("\n"); */
    
    bind = req->smpRequestBinds;
/*    orig = Snmpidstr->snmp_bind; */
    
    smxNameToText (text, (CIntfType) cmdTextSize,
		       Snmpidstr->snmp_orig,
		       (CIntfType) Snmpidstr->snmp_origlen);
/*		       (CBytePtrType) orig->smpBindName,
/*		       (CIntfType) orig->smpBindNameLen); */
/*    printf("original = '%s'\n", text); */
    smxNameToText (text, (CIntfType) cmdTextSize,
		       (CBytePtrType) bind->smpBindName,
		       (CIntfType) bind->smpBindNameLen);
/*    printf("reply = '%s'\n", text); */
    if((cmp = bcmp ((char *) bind->smpBindName,
	     (char *) Snmpidstr->snmp_orig,
	     (int) Snmpidstr->snmp_origlen)) != 0) {
/*	     (char *) orig->smpBindName,
/*	     (int) orig->smpBindNameLen)) != 0) { */
	if(Debug)
	    printf("end of query (cmp = %d)\n", cmp);
	Snmpidstr->snmp_flags |= SNMP_DONE;
	return(errOk);
    }

    for (i = req->smpRequestCount; i != 0; i--) {
	if (smxNameToText (text, (CIntfType) cmdTextSize,
			   (CBytePtrType) bind->smpBindName,
			   (CIntfType) bind->smpBindNameLen) >=
	    (CIntfType) 0) {
/*	    printf ("Name: %s\n", text); */
	}
/*	printf ("Kind: %s\n", smxKindToText (bind->smpBindKind)); */
	if (smxValueToText (text, (CIntfType) cmdTextSize,
			    bind) >= (CIntfType) 0) {
/*	    printf ("Value: %s\n", text); */
	    (*Storeroutine)(req);
	}
	else {
	    if(Debug)
		printf ("Value: GARBLED\n");
	}
/*	printf ("\n"); */
	bind++;
    }
    
    bind = req->smpRequestBinds;
    
    if(Snmpidstr->snmp_req->smpRequestCmd == smpCommandNext) {
/*	printf("next command\n"); */
	if (req->smpRequestError == smpErrorNone) {
/*	    printf("next command - no error\n"); */
	    cmp = 0;
/*	    for (i = req->smpRequestCount; (i != 0) &&
/*		 ((cmp = bcmp ((char *) bind->smpBindName,
/*			       (char *) Snmpidstr->snmp_orig,
/*			       (int) Snmpidstr->snmp_origlen)) == 0); i--) {*/
/*			       (char *) orig->smpBindName,
/*			       (int) orig->smpBindNameLen)) == 0); i--) { */
		smxNameToText (text, (CIntfType) cmdTextSize,
			       (CBytePtrType) bind->smpBindName,
			       (CIntfType) bind->smpBindNameLen);
		if(Debug)
		    printf("reply(%d) = '%s'\n", i, text);
/*		orig++; */
/*		break; */
/*		bind++; */
/*	    } */
	    if(bcmp ((char *) bind->smpBindName,
		     (char *) Snmpidstr->snmp_orig,
		     (int) Snmpidstr->snmp_origlen) == 0) {
/*	    if (cmp == 0) { */
		if(Debug)
		    printf("next command - reissue\n");
/*		printf("resending query (%s)\n", text); */
		req->smpRequestCmd = smpCommandNext;
		req->smpRequestId++;
		(void) smpRequest (smp, req);
	    }
	    else {
		Snmpidstr->snmp_flags |= SNMP_DONE;
	    }
	}
	else {
	    Snmpidstr->snmp_flags |= SNMP_DONE;
	}
    } else
	Snmpidstr->snmp_flags |= SNMP_DONE;

    return (errOk);
}

SmpBindType *freebinds(binds) SmpBindType *binds; {

    free(binds);

    return((SmpBindType *)NULL);
}

sendsnmp(hptr, communityname, mibloc, snmpcommand, snmpidstr)
HOSTENTRY	*hptr;
char		*communityname, *mibloc;
SmpCommandType	snmpcommand;
SNMPIDSTR	*snmpidstr; {
    IFENTRY			*ifptr;
    char			*bp;
    int				len;
    SmpIdType			smp;
    SmpSocketType		udp;
    SmpRequestType		*req;
    static struct servent	*servent=(struct servent *)NULL;

    /* Find a good IP address to send the request to */
    for(ifptr = hptr->hl_if
	; ifptr && ifptr->if_addr.s_addr == LOCALHOST
	; ifptr = ifptr->if_next) ;

    if((snmpidstr->snmp_bind = (SmpBindType *)malloc(cmdBindListSize
						     * sizeof(SmpBindType)))
       == (SmpBindType *)NULL) return(-1);

    if(servent == (struct servent *)NULL
       && (servent = getservbyname("snmp", "udp")) == (struct servent *)NULL)
	return(-1);

    cmdInit();

    if((bp = (char *)malloc(cmdBufferSize * sizeof(CByteType)))
       == (char *)NULL) {
	if(snmpidstr->snmp_bind)
	    snmpidstr->snmp_bind = freebinds(snmpidstr->snmp_bind);
	return(-1);
    }
    
    if((len = smxTextToObjectId(bp, cmdBufferSize, mibloc))
       < (CIntfType)0) {
	if(snmpidstr->snmp_bind)
	    snmpidstr->snmp_bind = freebinds(snmpidstr->snmp_bind);
	if(bp)
	    free(bp);
	return(-1);
    }

    if((snmpidstr->snmp_orig = (SmpNameType *)malloc(cmdBufferSize))
       == (SmpNameType *)NULL) {
	if(snmpidstr->snmp_bind)
	    snmpidstr->snmp_bind = freebinds(snmpidstr->snmp_bind);
	if(bp)
	    free(bp);
	return(-1);
    }
    /* another copy - used by t_remove... later */
    bcopy(bp, snmpidstr->snmp_orig, len);
    snmpidstr->snmp_origlen = len;

    snmpidstr->snmp_bind->smpBindName = (SmpNameType)bp;
    snmpidstr->snmp_bind->smpBindNameLen = (SmpLengthType)len;
    snmpidstr->snmp_bind->smpBindKind = smpKindOctetString;
    snmpidstr->snmp_bind->smpBindValue = (SmpValueType)0;
    snmpidstr->snmp_bind->smpBindValueLen = (SmpLengthType)0;

    if((snmpidstr->snmp_socket = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
	if(snmpidstr->snmp_bind)
	    snmpidstr->snmp_bind = freebinds(snmpidstr->snmp_bind);
	if(bp)
	    free(bp);
	return(-1);
    }

    /* non-blocking */
    len = 1;
    ioctl(snmpidstr->snmp_socket, FIONBIO, &len);

    udp = udpNew(snmpidstr->snmp_socket, ifptr->if_addr.s_addr
				 , (u_short)servent->s_port);
    snmpidstr->snmp_udp = udp;
    if((smp = smpNew(udp, udpSend, myUpCall)) == (SmpIdType)0) {
	fprintf(stderr, "Error creating protocol object\n");
	udp = udpFree(udp);
	if(snmpidstr->snmp_bind)
	    snmpidstr->snmp_bind = freebinds(snmpidstr->snmp_bind);
	if(bp)
	    free(bp);
	return(-1);
    }

    if((req = (SmpRequestType *)malloc(sizeof(SmpRequestType)))
       == (SmpRequestType *)NULL) {
	smp = smpFree(smp);
	udp = udpFree(udp);
	if(snmpidstr->snmp_bind)
	    snmpidstr->snmp_bind = freebinds(snmpidstr->snmp_bind);
	if(bp)
	    free(bp);
	return(-1);
    }
    snmpidstr->snmp_req = req;

    req->smpRequestCmd = snmpcommand;
    req->smpRequestCommunity = apsNew((ApsNameType)communityname
					 , (ApsNameType)"trivial"
					 , (ApsGoodiesType)0);
    req->smpRequestId = 0;
    req->smpRequestError = smpErrorNone;
    req->smpRequestIndex = (SmpIndexType)0;
    req->smpRequestCount = 1;
    req->smpRequestBinds = snmpidstr->snmp_bind;

    if(smpRequest(smp, req) != errOk) {
	fprintf(stderr, " Error sending protocol request\n");
	smp = smpFree(smp);
	udp = udpFree(udp);
	if(snmpidstr->snmp_bind)
	    snmpidstr->snmp_bind = freebinds(snmpidstr->snmp_bind);
	if(bp)
	    free(bp);
	if(snmpidstr->snmp_req) {
	    free(snmpidstr->snmp_req);
	    snmpidstr->snmp_req = 0;
	}
	return(-1);
    }

    smp = smpFree(smp);
    return(snmpidstr->snmp_socket);
}

freesnmpidstr(snmpidstr) SNMPIDSTR *snmpidstr; {
    int i;

    if(snmpidstr == (SNMPIDSTR *)NULL) return;

    snmpidstr->snmp_udp = udpFree(snmpidstr->snmp_udp);
    if(snmpidstr->snmp_bind->smpBindName)
	free(snmpidstr->snmp_bind->smpBindName);
    if(snmpidstr->snmp_bind) free(snmpidstr->snmp_bind);
    if(snmpidstr->snmp_orig) free(snmpidstr->snmp_orig);
    if(snmpidstr->snmp_buf) free(snmpidstr->snmp_buf);
    if(snmpidstr->snmp_socket != -1) close(snmpidstr->snmp_socket);
    if((snmpidstr->snmp_flags & SNMP_GLUE)
       && snmpidstr->snmp_glue) free(snmpidstr->snmp_glue);
    if(snmpidstr->snmp_req) free(snmpidstr->snmp_req);
    
    free(snmpidstr);
}

recvsnmp(snmpidstr, storeroutine)
SNMPIDSTR		*snmpidstr;
int			(*storeroutine)(); {
    int				salen;
    int				result;
    struct	sockaddr	saremote;
    
    u_long			fhost;
    u_short			fport;
    
    char			*buf;
    char			*bp;
    SmpIdType			smp;
    SmpSocketType		udp;
    
    udp = snmpidstr->snmp_udp;
    
/*    snmpidstr->snmp_flags &= ~SNMP_DONE; /* not done yet */
    
    do {
	smp = smpNew (udp, udpSend, myUpCall);
	buf = (char *)malloc(cmdBufferSize);
	snmpidstr->snmp_buf = buf;
	if (smp == (SmpIdType) 0) {
	    fprintf (stderr,
		     "Error creating protocol object\n");
/*	    udp = udpFree (udp); */
	    if(buf) {
		free(buf);
		snmpidstr->snmp_buf = 0;
	    }
	    smp = smpFree(smp);
	    if(Debug)
		printf("recvsnmp - smpNew failed\n");
	    return (FALSE);
	}
	
	salen = sizeof (saremote);
	result = recvfrom (snmpidstr->snmp_socket, (char *) buf
			   , (int) cmdBufferSize,
			   (int) 0, &saremote, &salen);
/*	printf("response is %d\n", result); */
	if(result == 0) {
	    if(Debug)
		printf("null response\n");
	    smp = smpFree(smp);
/*	    udp = udpFree(udp); */
	    if(buf) {
		free(buf);
		snmpidstr->snmp_buf = 0;
	    }
	    return(FALSE);
	}
	
	DEBUGBYTES (buf, result);
	DEBUG0 ("\n");
	
	Snmpidstr = snmpidstr;
	Storeroutine = storeroutine;
	
	if(result == -1) {
	    smp = smpFree(smp);
	    free(buf);
	    snmpidstr->snmp_buf = 0;
	} else
	    for (bp = buf; ((result > 0) &&
			    (smpInput (smp, *bp++) == errOk));
		 result--);
	
	DEBUG1 ("result: %d\n", result);
	smp = smpFree (smp);
	
    } while ((result >= 0) && (! (snmpidstr->snmp_flags & SNMP_DONE)));
    
    /*    udp = udpFree (udp); */
    /*    communityId = apsFree (communityId); */

    return(TRUE);
}

s_readsnmp(req) SmpRequestPtrType req; {
    char	buffer[512];
    char	buf[40];
    
    Snmpidstr->snmp_host->hl_flags &= ~FL_NOSNMP; /* has snmp! */

    sprintf(buf, "%s - %s", Snmpidstr->snmp_host->hl_displayname
	    , Snmpidstr->snmp_glue);

    smxValueToText (buffer, sizeof(buffer), req->smpRequestBinds);

    normalizetext(buffer);
    disptext(buf, buffer);
}

XtTimerCallbackProc t_removesnmp(snmpidstr) SNMPIDSTR *snmpidstr; {

    if(Debug)
	printf("Timeout called for %s\n", snmpidstr->snmp_host->hl_name);

    XtRemoveInput(snmpidstr->snmp_id);

    freesnmpidstr(snmpidstr);
}

char *extractip(name) char *name; {
    register char	*cp;
    register int	count;
    
    for(cp = &name[strlen(name)-1] , count = 0 ; cp > name && count < 4 ; cp--)
	if(*cp == '.') count++;

    cp += 2;

    if(Debug)
	printf("ipaddr='%s'\n", cp);

    return(cp);
}

s_readroutes(req) SmpRequestPtrType req; {
    char			buffer[512];
    char			valuebuf[40], namebuf[80];
    u_long			haddr;
    u_short			fport;
    SmpIdType			smp;
    SmpSocketType		udp;
    IFENTRY			*ifptr;

    Snmpidstr->snmp_host->hl_flags &= ~FL_NOSNMP; /* has snmp! */

    smxValueToText (valuebuf, sizeof(valuebuf), req->smpRequestBinds);

    smxNameToText(namebuf, sizeof(namebuf), req->smpRequestBinds->smpBindName
		  , req->smpRequestBinds->smpBindNameLen);

    if(Debug)
	printf("Got route of %s %s\n", namebuf, valuebuf);

    sprintf(buffer, "%15.15s   %15.15s\n", extractip(namebuf), valuebuf);
    appendstr(buffer
	      , &((ROUTETXTSTR *)(Snmpidstr->snmp_glue))->rts_buf
	      , &((ROUTETXTSTR *)(Snmpidstr->snmp_glue))->rts_size
	      , &((ROUTETXTSTR *)(Snmpidstr->snmp_glue))->rts_end);

    ((ROUTETXTSTR *)(Snmpidstr->snmp_glue))->rts_lastroute.s_addr
	= inet_addr(extractip(namebuf));

    if(Debug)
	printf("lastroute=%s\n"
       , inet_ntoa(((ROUTETXTSTR *)(Snmpidstr->snmp_glue))->rts_lastroute));

/*    haddr = inet_addr(buffer); */
    /* Store this info. away */
/*    ifptr = addif(Snmpidstr->snmp_host, haddr, 0);
/*    ifptr->if_flags |= FL_SNMP;
/*    Snmpidstr->snmp_host->hl_lastsnmpif = haddr; */
}

x_readroutes(snmpidstr) SNMPIDSTR *snmpidstr; {
    char	buffer[80];
    char	buf[40];
    u_long			haddr;
    u_short			fport;
    SmpIdType			smp;
    SmpSocketType		udp;
    IFENTRY			*ifptr;

    if(Debug)
	printf("read route table called for host %s\n"
	       , snmpidstr->snmp_host->hl_name);
    if(recvsnmp(snmpidstr, s_readroutes) != TRUE) {
	if(Debug)
	    printf("recvsnmp failed\n");
	freesnmpidstr(snmpidstr);
	return;
    }

    /* Display it */
    if(snmpidstr->snmp_flags & SNMP_DONE) {
	sprintf(buffer, "%s route table", snmpidstr->snmp_host->hl_name);
	disptext(buffer, ((ROUTETXTSTR *)(snmpidstr->snmp_glue))->rts_buf);
	if(snmpidstr->snmp_timeid)
	    XtRemoveTimeOut(snmpidstr->snmp_timeid);
	t_removesnmp(snmpidstr);
    }

    return;
}

XtTimerCallbackProc t_removeroute(snmpidstr) SNMPIDSTR *snmpidstr; {
    char	buffer[80];
    SmpIdType	smp;

    sprintf(buffer, "1.3.6.1.2.1.4.21.1.7.%s"
	    , inet_ntoa(((ROUTETXTSTR *)(snmpidstr->snmp_glue))->rts_lastroute));
    if(++snmpidstr->snmp_count > SNMPMAXTRIES) {
	snmpidstr->snmp_flags |= SNMP_DONE;
	sprintf(buffer, "%s (partial list of routes)"
		, snmpidstr->snmp_host->hl_name);
	disptext(buffer, ((ROUTETXTSTR *)(snmpidstr->snmp_glue))->rts_buf);
	if(snmpidstr->snmp_timeid)
	    XtRemoveTimeOut(snmpidstr->snmp_timeid);
	t_removesnmp(snmpidstr);
	return;
    }

    smp = smpNew(snmpidstr->snmp_udp, udpSend, myUpCall);

    /* Setup new query */
    free(snmpidstr->snmp_bind->smpBindName);
    snmpidstr->snmp_bind->smpBindName = (CBytePtrType)malloc(cmdBufferSize);
    snmpidstr->snmp_bind->smpBindNameLen
	= smxTextToObjectId(snmpidstr->snmp_bind->smpBindName, cmdBufferSize
			    , buffer);
    snmpidstr->snmp_req->smpRequestBinds = snmpidstr->snmp_bind;

    sprintf(buffer, "Resending ipRouteTable query for host %s"
	    , snmpidstr->snmp_host->hl_name);
    dispnotice("Route-note", buffer);
    smpRequest(smp, snmpidstr->snmp_req);

/*    if(sendsnmp(snmpidstr->snmp_host, snmpidstr->snmp_host->hl_community
/*		, buffer, smpCommandNext, snmpidstr) == -1) {
/*	free(snmpidstr);
/*	return(FALSE);
/*    } */

    XtRemoveInput(snmpidstr->snmp_id);
    snmpidstr->snmp_id = XtAddInput(snmpidstr->snmp_socket
				    , (XtPointer)XtInputReadMask
				    , (XtInputCallbackProc)x_readroutes
				    , (XtPointer)snmpidstr);

    snmpidstr->snmp_timeid
	= XtAppAddTimeOut(XtWidgetToApplicationContext(Toplevel)
			  , SNMPQUERYTIMEOUT * 1000
			  , (XtTimerCallbackProc)t_removeroute
			  , (XtPointer)snmpidstr);
}

XtInputCallbackProc x_readsnmp(snmpidstr) SNMPIDSTR *snmpidstr; {
    char	buffer[512];
    char	buf[40];
    
    recvsnmp(snmpidstr, s_readsnmp);
    
    if(snmpidstr->snmp_flags & SNMP_DONE) {
	if(snmpidstr->snmp_timeid)
	    XtRemoveTimeOut(snmpidstr->snmp_timeid);
	t_removesnmp(snmpidstr);
    }
}

/*
 * Allocate a new snmpidstr
 */
SNMPIDSTR *newsnmpidstr() {
    register SNMPIDSTR	*snmpidstr;
    
    if((snmpidstr = (SNMPIDSTR *)malloc(sizeof(SNMPIDSTR)))
       == (SNMPIDSTR *)NULL) return((SNMPIDSTR *)NULL);

    /* init. */
    snmpidstr->snmp_next = Snmpids;
    snmpidstr->snmp_id = 0;
    snmpidstr->snmp_timeid = 0;
    snmpidstr->snmp_host = (HOSTENTRY *)NULL;
    snmpidstr->snmp_bind = (SmpBindType *)NULL;
    snmpidstr->snmp_orig = (SmpNameType *)NULL;
    snmpidstr->snmp_origlen = (SmpLengthType)0;
    snmpidstr->snmp_req = (SmpRequestType *)NULL;
    snmpidstr->snmp_count = 0;
    snmpidstr->snmp_flags = 0;
    snmpidstr->snmp_socket = -1;
    snmpidstr->snmp_udp = (SmpSocketType)NULL;
    snmpidstr->snmp_buf = (char *)NULL;
    snmpidstr->snmp_glue = (void *)NULL;

    Snmpids = snmpidstr;

    return(snmpidstr);
}

/* Menu items */
void snmp_sysDescr() {
    HOSTENTRY	*hptr;
    SNMPIDSTR	*snmpidstr;
    SmpBindType *bindlist;

    if((hptr = widgettohost(Hostwidget)) == (HOSTENTRY *)NULL) return;

    snmpidstr = newsnmpidstr();
    snmpidstr->snmp_glue = "sysDescr";
    if(sendsnmp(hptr, hptr->hl_community
		, "1.3.6.1.2.1.1.1.0", smpCommandGet, snmpidstr) == -1) {
	free(snmpidstr);
	return;
    }
    snmpidstr->snmp_host = hptr;
    snmpidstr->snmp_id = XtAddInput(snmpidstr->snmp_socket
				    , (XtPointer)XtInputReadMask
				    , (XtInputCallbackProc)x_readsnmp
				    , (XtPointer)snmpidstr);
    snmpidstr->snmp_timeid
	= XtAppAddTimeOut(XtWidgetToApplicationContext(Toplevel)
			  , SNMPQUERYTIMEOUT * 1000
			  , (XtTimerCallbackProc)t_removesnmp
			  , (XtPointer)snmpidstr);
}

s_readtable(req) SmpRequestPtrType req; {
    char	buffer[512];
    char	buf[40];
    u_long			haddr;
    u_short			fport;
    SmpIdType			smp;
    SmpSocketType		udp;
    IFENTRY			*ifptr;

    Snmpidstr->snmp_host->hl_flags &= ~FL_NOSNMP; /* has snmp! */

    smxValueToText (buffer, sizeof(buffer), req->smpRequestBinds);

    if(Debug)
	printf("Got address of %s\n", buffer);
    haddr = inet_addr(buffer);
    /* Store this info. away */
    ifptr = addif(Snmpidstr->snmp_host, haddr, 0 /* don't know netmask */);
    ifptr->if_flags |= FL_SNMP;
    Snmpidstr->snmp_host->hl_lastsnmpif = haddr;
}

x_readtable(snmpidstr) SNMPIDSTR *snmpidstr; {
    char	buffer[512];
    char	buf[40];
    u_long			haddr;
    u_short			fport;
    SmpIdType			smp;
    SmpSocketType		udp;
    IFENTRY			*ifptr;

    if(Debug)
	printf("read addr table called for host %s\n"
	       , snmpidstr->snmp_host->hl_name);
    if(recvsnmp(snmpidstr, s_readtable) != TRUE) {
	if(Debug)
	    printf("recvsnmp failed\n");
	freesnmpidstr(snmpidstr);
    }

    if(snmpidstr->snmp_flags & SNMP_DONE) {
	snmpidstr->snmp_host->hl_flags |= FL_SNMPDONE; /* completely done */
	if(snmpidstr->snmp_timeid)
	    XtRemoveTimeOut(snmpidstr->snmp_timeid);
	t_removesnmp(snmpidstr);
    }

    return;
}

host_ipAddrTable(hptr) HOSTENTRY *hptr; {
    SNMPIDSTR	*snmpidstr;
    SmpBindType *bindlist;
    
    snmpidstr = newsnmpidstr();
    if(hptr->hl_lastsnmp == 0)
	hptr->hl_lastsnmp = time(0L); /* time of query */
    if(sendsnmp(hptr, hptr->hl_community
		, "1.3.6.1.2.1.4.20.1.1", smpCommandNext, snmpidstr) == -1) {
	free(snmpidstr);
	return(FALSE);
    }
    if(Debug)
	printf("query sent\n");
    snmpidstr->snmp_host = hptr;
    snmpidstr->snmp_id = XtAddInput(snmpidstr->snmp_socket
				    , (XtPointer)XtInputReadMask
				    , (XtInputCallbackProc)x_readtable
				    , (XtPointer)snmpidstr);
    snmpidstr->snmp_timeid
	= XtAppAddTimeOut(XtWidgetToApplicationContext(Toplevel)
			  , SNMPQUERYTIMEOUT * 1000
			  , (XtTimerCallbackProc)t_removesnmp
			  , (XtPointer)snmpidstr);
}

void snmp_ipAddrTable() {
    HOSTENTRY	*hptr;

    if((hptr = widgettohost(Hostwidget)) == (HOSTENTRY *)NULL) return;

    host_ipAddrTable(hptr);
}


extractindex(name) char *name; {
    register char	*cp;

    for(cp = &name[strlen(name)] ; cp > name && *cp != '.' ; cp--) ;

    if(cp == name) return(-1);

    return(atoi(++cp));
}

s_readmask(req) SmpRequestPtrType req; {
    char	name[80];
    char	value[40];
    u_long	addr;
    IFENTRY	*ifptr;

    Snmpidstr->snmp_host->hl_flags &= ~FL_NOSNMP; /* has snmp! */

    smxNameToText(name, sizeof(name), Snmpidstr->snmp_bind->smpBindName
		  , Snmpidstr->snmp_bind->smpBindNameLen);
    if(Debug) {
	printf("name=%s\n", name);
	printf("hostaddr=%s", extractip(name));
    }
    smxValueToText (value, sizeof(value), req->smpRequestBinds);

    if(Debug)
	printf("value (mask) = '%s'\n", value);

    addr = inet_addr(extractip(name));
    if((ifptr = addifmask(Snmpidstr->snmp_host, addr, inet_addr(value)))
       != (IFENTRY *)NULL)
	ifptr->if_flags |= FL_SNMPMASK; /* snmp derived info */
}

XtInputCallbackProc x_readmask(snmpidstr) SNMPIDSTR *snmpidstr; {
    char	name[80];
    char	value[40];
    u_long	addr, mask;

    recvsnmp(snmpidstr, s_readmask);

    if(snmpidstr->snmp_flags & SNMP_DONE) {
	if(snmpidstr->snmp_timeid)
	    XtRemoveTimeOut(snmpidstr->snmp_timeid);
	t_removesnmp(snmpidstr);
    }
}

snmp_ipAdEntNetMask(ifptr) IFENTRY *ifptr; {
    HOSTENTRY	*hptr;
    SNMPIDSTR	*snmpidstr;
    SmpBindType *bindlist;
    char	buffer[80];
    
    hptr = ifptr->if_host;

    snmpidstr = newsnmpidstr();
    sprintf(buffer, "1.3.6.1.2.1.4.20.1.3.%s", inet_ntoa(ifptr->if_addr));
    if(sendsnmp(hptr, hptr->hl_community
		   , buffer, smpCommandGet, snmpidstr) == -1) {
	free(snmpidstr);
	return(FALSE);
    }
    snmpidstr->snmp_host = hptr;
    snmpidstr->snmp_id = XtAddInput(snmpidstr->snmp_socket
				    , (XtPointer)XtInputReadMask
    				    , (XtInputCallbackProc)x_readmask
				    , (XtPointer)snmpidstr);
    snmpidstr->snmp_timeid
	= XtAppAddTimeOut(XtWidgetToApplicationContext(Toplevel)
			  , SNMPQUERYTIMEOUT * 1000
			  , (XtTimerCallbackProc)t_removesnmp
			  , (XtPointer)snmpidstr);
}

s_readindex(req) SmpRequestPtrType req; {
    char	name[80];
    char	value[40];
    u_long	addr, mask;

    Snmpidstr->snmp_host->hl_flags &= ~FL_NOSNMP; /* has snmp! */

    smxNameToText(name, sizeof(name), Snmpidstr->snmp_bind->smpBindName
		  , Snmpidstr->snmp_bind->smpBindNameLen);
    if(Debug)
	printf("address %s ", name);
    smxValueToText (value, sizeof(value), req->smpRequestBinds);
    if(Debug)
	printf("has index %s\n", value);

    addr = inet_addr(extractip(name));
    addifindex(addr, atoi(value));
}

XtInputCallbackProc x_readindex(snmpidstr) SNMPIDSTR *snmpidstr; {
    char	name[80];
    char	value[40];
    u_long	addr, mask;

    recvsnmp(snmpidstr, s_readindex);

    if(snmpidstr->snmp_flags & SNMP_DONE) {
	if(snmpidstr->snmp_timeid)
	    XtRemoveTimeOut(snmpidstr->snmp_timeid);
	t_removesnmp(snmpidstr);
    }
}

snmp_ipAdEntIfIndex(ifptr) IFENTRY *ifptr; {
    HOSTENTRY	*hptr;
    SNMPIDSTR	*snmpidstr;
    SmpBindType *bindlist;
    char	buffer[80];
    
    hptr = ifptr->if_host;

    snmpidstr = newsnmpidstr();
    sprintf(buffer, "1.3.6.1.2.1.4.20.1.2.%s"
	    , inet_ntoa(ifptr->if_addr));
    if(sendsnmp(hptr, hptr->hl_community
		   , buffer, smpCommandGet, snmpidstr) == -1) {
	free(snmpidstr);
	return(FALSE);
    }
    snmpidstr->snmp_host = hptr;
    snmpidstr->snmp_id = XtAddInput(snmpidstr->snmp_socket
				    , (XtPointer)XtInputReadMask
				    , (XtInputCallbackProc)x_readindex
				    , (XtPointer)snmpidstr);
    snmpidstr->snmp_timeid
	= XtAppAddTimeOut(XtWidgetToApplicationContext(Toplevel)
			  , SNMPQUERYTIMEOUT * 1000
			  , (XtTimerCallbackProc)t_removesnmp
			  , (XtPointer)snmpidstr);
}

s_readspeed(req) SmpRequestPtrType req; {
    char	name[80];
    char	value[40];
    int		index;
    IFENTRY	*ifptr;

    Snmpidstr->snmp_host->hl_flags &= ~FL_NOSNMP; /* has snmp! */

    smxNameToText(name, sizeof(name), Snmpidstr->snmp_bind->smpBindName
		  , Snmpidstr->snmp_bind->smpBindNameLen);
    index = extractindex(name);
    if(Debug)
	printf("host %s index %d ", Snmpidstr->snmp_host->hl_name, index);
    smxValueToText (value, sizeof(value), req->smpRequestBinds);
    if(Debug)
	printf("has speed %s\n", value);

    if((ifptr = ifindextoif(Snmpidstr->snmp_host, index)) != (IFENTRY *)NULL)
	addifindspeed(Snmpidstr->snmp_host, index, atoi(value));
}

XtInputCallbackProc x_readspeed(snmpidstr) SNMPIDSTR *snmpidstr; {
    char	name[80];
    char	value[40];
    u_long	addr, mask;

    recvsnmp(snmpidstr, s_readspeed);

    if(snmpidstr->snmp_flags & SNMP_DONE) {
	if(snmpidstr->snmp_timeid)
	    XtRemoveTimeOut(snmpidstr->snmp_timeid);
	t_removesnmp(snmpidstr);
    }
}

snmp_IfSpeed(hptr, index) HOSTENTRY *hptr; int index; {
    SNMPIDSTR	*snmpidstr;
    SmpBindType *bindlist;
    char	buffer[80];
    
    snmpidstr = newsnmpidstr();
    sprintf(buffer, "1.3.6.1.2.1.2.2.1.5.%d", index);
    if(sendsnmp(hptr, hptr->hl_community
		   , buffer, smpCommandGet, snmpidstr) == -1) {
	free(snmpidstr);
	return(FALSE);
    }
    snmpidstr->snmp_host = hptr;
    snmpidstr->snmp_id = XtAddInput(snmpidstr->snmp_socket
				    , (XtPointer)XtInputReadMask
				    , (XtInputCallbackProc)x_readspeed
				    , (XtPointer)snmpidstr);
    snmpidstr->snmp_timeid
	= XtAppAddTimeOut(XtWidgetToApplicationContext(Toplevel)
			  , SNMPQUERYTIMEOUT * 1000
			  , (XtTimerCallbackProc)t_removesnmp
			  , (XtPointer)snmpidstr);
}

s_readstatus(req) SmpRequestPtrType req; {
    char	name[80];
    char	value[40];
    int		index, i;
    IFENTRY	*ifptr;

    Snmpidstr->snmp_host->hl_flags &= ~FL_NOSNMP; /* has snmp! */

    smxNameToText(name, sizeof(name), Snmpidstr->snmp_bind->smpBindName
		  , Snmpidstr->snmp_bind->smpBindNameLen);
    index = extractindex(name);
    if(Debug)
	printf("host %s index %d ", Snmpidstr->snmp_host->hl_name, index);
    smxValueToText (value, sizeof(value), req->smpRequestBinds);
    if(Debug)
	printf("has status %s\n", value);

    setifindstatus(Snmpidstr->snmp_host, index, atoi(value));
}

XtInputCallbackProc x_readstatus(snmpidstr) SNMPIDSTR *snmpidstr; {
    char	name[80];
    char	value[40];
    u_long	addr, mask;

    recvsnmp(snmpidstr, s_readstatus);

    if(snmpidstr->snmp_flags & SNMP_DONE) {
	if(snmpidstr->snmp_timeid)
	    XtRemoveTimeOut(snmpidstr->snmp_timeid);
	t_removesnmp(snmpidstr);
    }
}

snmp_IfOperStatus(hptr, index) HOSTENTRY *hptr; int index; {
    SNMPIDSTR	*snmpidstr;
    SmpBindType *bindlist;
    char	buffer[80];
    
    snmpidstr = newsnmpidstr();
    sprintf(buffer, "1.3.6.1.2.1.2.2.1.8.%d", index);
    if(sendsnmp(hptr, hptr->hl_community
		   , buffer, smpCommandGet, snmpidstr) == -1) {
	free(snmpidstr);
	return(FALSE);
    }
    snmpidstr->snmp_host = hptr;
    snmpidstr->snmp_id = XtAddInput(snmpidstr->snmp_socket
				    , (XtPointer)XtInputReadMask
				    , (XtInputCallbackProc)x_readstatus
				    , (XtPointer)snmpidstr);
    snmpidstr->snmp_timeid
	= XtAppAddTimeOut(XtWidgetToApplicationContext(Toplevel)
			  , SNMPQUERYTIMEOUT * 1000
			  , (XtTimerCallbackProc)t_removesnmp
			  , (XtPointer)snmpidstr);
}

/*
 * Send SNMP ipAddrTable query to every host to make sure we find all of
 * their interfaces.
 */
XtTimerCallbackProc snmphosts() {
    static HOSTENTRY	*hptr=(HOSTENTRY *)NULL;
    u_long	now;

    now = time(0L);

    if(hptr == (HOSTENTRY *)NULL) hptr = Hostlist;

    if(hptr != (HOSTENTRY *)NULL) {
	/* Time to try this system again? */
	if((hptr->hl_flags & FL_NOSNMP)
	   && (now - hptr->hl_lastsnmp) > SNMPTRYAGAIN) {
	    hptr->hl_flags &= ~FL_NOSNMP; /* try again */
	    hptr->hl_lastsnmp = 0;
	}
	
	if(! (hptr->hl_flags & (FL_SNMPDONE | FL_NOSNMP))) {
	    
	    /* Assume this one doesn't respond? */
	    if(hptr->hl_lastsnmpif == 0 && (now - hptr->hl_lastsnmp)
	       > SNMPMAXTRIES * SNMPQUERYINTERVAL) {
		hptr->hl_flags |= FL_NOSNMP; /* doesn't have snmp */
	    }
	    if(Debug)
		printf("SNMP ipAddrTable query for %s\n", hptr->hl_name);
	    host_ipAddrTable(hptr);
	}
	
	/* Set to next host */
	hptr = hptr->hl_next;
    }

    XtAppAddTimeOut(XtWidgetToApplicationContext(Toplevel)
		    , (u_long)(2 * 1000)
		    , (XtTimerCallbackProc)snmphosts, (XtPointer)NULL);
}

XtTimerCallbackProc snmpifs() {
    static IFENTRY	*ifptr=(IFENTRY *)NULL;

    if(ifptr == (IFENTRY *)NULL) ifptr = Ifentries;

    collectsnmp(ifptr);

    if(ifptr) ifptr = ifptr->if_nextif;

    XtAppAddTimeOut(XtWidgetToApplicationContext(Toplevel)
		    , (u_long)(1 * 1000), (XtTimerCallbackProc)snmpifs
		    , (XtPointer)NULL);
}

/*
 * Collect SNMP information for interfaces
 */
collectsnmp(ifptr) IFENTRY *ifptr; {
    u_long	now;

    if(ifptr == (IFENTRY *)NULL) return;

    now = time(0L);

    if(ifptr->if_lastsnmp == 0)
	ifptr->if_lastsnmp = time(0L);

    /* Should we start up again? */
    if((ifptr->if_flags & FL_NOSNMP)
       && (now - ifptr->if_lastsnmp) > SNMPTRYAGAIN) {
	ifptr->if_flags &= ~FL_NOSNMP; /* try again */
	ifptr->if_lastsnmp = 0;
    }

    if(! (ifptr->if_flags & FL_NOSNMP)) {

	/* Assume this one doesn't respond? */
	if((now - ifptr->if_lastsnmp) > SNMPMAXTRIES * SNMPQUERYINTERVAL)
	    ifptr->if_flags |= FL_NOSNMP; /* doesn't have snmp */

	/* See if we need to collect the netmask mask
	 * If we haven't already gotten it from snmp info. and
	 * if it wasn't configured in the configuration file
	 */
	if(Debug)
	    fprintf(stderr, "interface %s flags = 0x%x\n"
			, inet_ntoa(ifptr->if_addr), ifptr->if_flags);

	/* Get the interface index number for this interface */
	if(ifptr->if_index == 0177) {
	    snmp_ipAdEntIfIndex(ifptr);
	    return;			/* can't do any more right now */
	} 
	
	/*
	 * If this interface is down, see if it's come back up every now
	 * and then
	 */
	if((now - ifptr->if_lastup) > TESTIFUPTIME)
	    ifptr->if_flags &= ~(FL_UP | FL_DOWN); /* set unknown */

	/* Get operational status */
	if(!(ifptr->if_flags & (FL_UP | FL_DOWN))) {
	    snmp_IfOperStatus(ifptr->if_host, ifptr->if_index);
	}

	if(!(ifptr->if_flags & FL_DOWN)
	   && ifptr->if_addr.s_addr != LOCALHOST
	   && !(ifptr->if_flags & FL_SNMPMASK)
	   && !(ifptr->if_flags & FL_CONFMASK))
	    snmp_ipAdEntNetMask(ifptr);
	
	/* Get interface speed */
	if(ifptr->if_addr.s_addr != LOCALHOST && ifptr->if_speed == 0) {
	    snmp_IfSpeed(ifptr->if_host, ifptr->if_index);
	    return;			/* can't do any more right now */
	}

    }
}

/*
 * Get this host's Route table
 */
void snmp_ipRouteTableEntry(hptr, query) HOSTENTRY *hptr; char *query; {
    SNMPIDSTR	*snmpidstr;
    SmpBindType *bindlist;

    snmpidstr = newsnmpidstr();
    if(hptr->hl_lastsnmp == 0)
	hptr->hl_lastsnmp = time(0L); /* time of query */
    if(sendsnmp(hptr, hptr->hl_community
		, query, smpCommandNext, snmpidstr) == -1) {
	free(snmpidstr);
	return;
    }
    if(Debug)
	printf("query sent (%s)\n", query);
    snmpidstr->snmp_host = hptr;
    snmpidstr->snmp_id = XtAddInput(snmpidstr->snmp_socket
				    , (XtPointer)XtInputReadMask
				    , (XtInputCallbackProc)x_readroutes
				    , (XtPointer)snmpidstr);
    snmpidstr->snmp_timeid
	= XtAppAddTimeOut(XtWidgetToApplicationContext(Toplevel)
			  , SNMPQUERYTIMEOUT * 1000
			  , (XtTimerCallbackProc)t_removeroute
			  , (XtPointer)snmpidstr);
    snmpidstr->snmp_flags &= ~SNMP_DONE;
    snmpidstr->snmp_glue = (char *)malloc(sizeof(ROUTETXTSTR));
    if((ROUTETXTSTR *)(snmpidstr->snmp_glue) == (ROUTETXTSTR *)NULL) {
	XtRemoveTimeOut(snmpidstr->snmp_timeid);
	t_removesnmp(snmpidstr);
    } else {
	snmpidstr->snmp_flags |= SNMP_GLUE; /* make sure we free this */
	((ROUTETXTSTR *)(snmpidstr->snmp_glue))->rts_buf = (char *)NULL;
	((ROUTETXTSTR *)(snmpidstr->snmp_glue))->rts_end = (char *)NULL;
	((ROUTETXTSTR *)(snmpidstr->snmp_glue))->rts_size = 0;
	((ROUTETXTSTR *)(snmpidstr->snmp_glue))->rts_lastroute.s_addr = 0;
    }
}

void snmp_ipRouteTable() {
    HOSTENTRY	*hptr;

    if((hptr = widgettohost(Hostwidget)) == (HOSTENTRY *)NULL) return;

    snmp_ipRouteTableEntry(hptr, "1.3.6.1.2.1.4.21.1.7");
}

void snmp_sysLocation() {
    HOSTENTRY	*hptr;
    SNMPIDSTR	*snmpidstr;
    SmpBindType *bindlist;

    if((hptr = widgettohost(Hostwidget)) == (HOSTENTRY *)NULL) return;

    snmpidstr = newsnmpidstr();
    snmpidstr->snmp_glue = "sysLocation";
    if(sendsnmp(hptr, hptr->hl_community
		, "1.3.6.1.2.1.1.6.0", smpCommandGet, snmpidstr) == -1) {
	free(snmpidstr);
	return;
    }
    snmpidstr->snmp_host = hptr;
    snmpidstr->snmp_id = XtAddInput(snmpidstr->snmp_socket
				    , (XtPointer)XtInputReadMask
				    , (XtInputCallbackProc)x_readsnmp
				    , (XtPointer)snmpidstr);
    snmpidstr->snmp_timeid
	= XtAppAddTimeOut(XtWidgetToApplicationContext(Toplevel)
			  , SNMPQUERYTIMEOUT * 1000
			  , (XtTimerCallbackProc)t_removesnmp
			  , (XtPointer)snmpidstr);
}

void snmp_sysContact() {
    HOSTENTRY	*hptr;
    SNMPIDSTR	*snmpidstr;
    SmpBindType *bindlist;

    if((hptr = widgettohost(Hostwidget)) == (HOSTENTRY *)NULL) return;

    snmpidstr = newsnmpidstr();
    snmpidstr->snmp_glue = "sysContact";
    if(sendsnmp(hptr, hptr->hl_community
		, "1.3.6.1.2.1.1.4.0", smpCommandGet, snmpidstr) == -1) {
	free(snmpidstr);
	return;
    }
    snmpidstr->snmp_host = hptr;
    snmpidstr->snmp_id = XtAddInput(snmpidstr->snmp_socket
				    , (XtPointer)XtInputReadMask
				    , (XtInputCallbackProc)x_readsnmp
				    , (XtPointer)snmpidstr);
    snmpidstr->snmp_timeid
	= XtAppAddTimeOut(XtWidgetToApplicationContext(Toplevel)
			  , SNMPQUERYTIMEOUT * 1000
			  , (XtTimerCallbackProc)t_removesnmp
			  , (XtPointer)snmpidstr);
}

s_readuptime(req) SmpRequestPtrType req; {
    char	buffer[512];
    char	buf[40];
    
    Snmpidstr->snmp_host->hl_flags &= ~FL_NOSNMP; /* has snmp! */

    sprintf(buf, "%s - %s", Snmpidstr->snmp_host->hl_displayname
	    , Snmpidstr->snmp_glue);

    smxValueToText (buffer, sizeof(buffer), req->smpRequestBinds);

    /* Calculate the real time */
    /* Time we get from SNMP seems to be 100'th of second intervals */
    sprintf(buffer, "%s", time2str((u_long)(atoi(buffer)/100)));

    normalizetext(buffer);
    disptext(buf, buffer);
}

XtInputCallbackProc x_readuptime(snmpidstr) SNMPIDSTR *snmpidstr; {
    char	buffer[512];
    char	buf[40];
    
    recvsnmp(snmpidstr, s_readuptime);
    
    if(snmpidstr->snmp_flags & SNMP_DONE) {
	if(snmpidstr->snmp_timeid)
	    XtRemoveTimeOut(snmpidstr->snmp_timeid);
	t_removesnmp(snmpidstr);
    }
}

void snmp_sysUptime() {
    HOSTENTRY	*hptr;
    SNMPIDSTR	*snmpidstr;
    SmpBindType *bindlist;

    if((hptr = widgettohost(Hostwidget)) == (HOSTENTRY *)NULL) return;

    snmpidstr = newsnmpidstr();
    snmpidstr->snmp_glue = "sysUptime";
    if(sendsnmp(hptr, hptr->hl_community
		, "1.3.6.1.2.1.1.3.0", smpCommandGet, snmpidstr) == -1) {
	free(snmpidstr);
	return;
    }
    snmpidstr->snmp_host = hptr;
    snmpidstr->snmp_id = XtAddInput(snmpidstr->snmp_socket
				    , (XtPointer)XtInputReadMask
				    , (XtInputCallbackProc)x_readuptime
				    , (XtPointer)snmpidstr);
    snmpidstr->snmp_timeid
	= XtAppAddTimeOut(XtWidgetToApplicationContext(Toplevel)
			  , SNMPQUERYTIMEOUT * 1000
			  , (XtTimerCallbackProc)t_removesnmp
			  , (XtPointer)snmpidstr);
}

s_gettrafin(req) SmpRequestPtrType req; {
    char	name[80];
    char	value[40];
    int		index;
    int		i;
    Widget	w;
    float	lastval;
    u_long	lasttime;
    u_long	now;
    float	newvalue;
    float	curvalue;

    now = time(0L);

    Snmpidstr->snmp_host->hl_flags &= ~FL_NOSNMP; /* has snmp! */

    w = ((TRAFFICINFO *)Snmpidstr->snmp_glue)->tri_inw;
    lastval = ((TRAFFICINFO *)Snmpidstr->snmp_glue)->tri_lastinval;
    lasttime = ((TRAFFICINFO *)Snmpidstr->snmp_glue)->tri_lastintime;

    smxNameToText(name, sizeof(name), Snmpidstr->snmp_bind->smpBindName
		  , Snmpidstr->snmp_bind->smpBindNameLen);
    index = extractindex(name);
    if(Debug)
	printf("host %s index %d ", Snmpidstr->snmp_host->hl_name, index);
    smxValueToText (value, sizeof(value), req->smpRequestBinds);
    if(Debug)
	printf("has input traffic %s\n", value);

    sscanf(value, "%f", &curvalue);
    ((TRAFFICINFO *)Snmpidstr->snmp_glue)->tri_lastinval = curvalue;
    ((TRAFFICINFO *)Snmpidstr->snmp_glue)->tri_lastintime = now;

    if(lastval != 0) {
 	newvalue = (curvalue - lastval) / (now - lasttime);
	sprintf(name, "%.2f cps", newvalue);

	i = 0;
	XtSetArg(Args[i], XtNstring, name); i++;
	XtSetValues(w, Args, i);
    }
}

s_gettrafout(req) SmpRequestPtrType req; {
    char	name[80];
    char	value[40];
    int		index;
    int		i;
    Widget	w;
    float	lastval;
    u_long	lasttime;
    u_long	now;
    float	newvalue;
    float	curvalue;

    now = time(0L);

    Snmpidstr->snmp_host->hl_flags &= ~FL_NOSNMP; /* has snmp! */

    w = ((TRAFFICINFO *)Snmpidstr->snmp_glue)->tri_outw;
    lastval = ((TRAFFICINFO *)Snmpidstr->snmp_glue)->tri_lastoutval;
    lasttime = ((TRAFFICINFO *)Snmpidstr->snmp_glue)->tri_lastouttime;

    smxNameToText(name, sizeof(name), Snmpidstr->snmp_bind->smpBindName
		  , Snmpidstr->snmp_bind->smpBindNameLen);
    index = extractindex(name);
    if(Debug)
	printf("host %s index %d ", Snmpidstr->snmp_host->hl_name, index);
    smxValueToText (value, sizeof(value), req->smpRequestBinds);
    if(Debug)
	printf("has output traffic %s\n", value);

    sscanf(value, "%f", &curvalue);
    ((TRAFFICINFO *)Snmpidstr->snmp_glue)->tri_lastoutval = curvalue;
    ((TRAFFICINFO *)Snmpidstr->snmp_glue)->tri_lastouttime = now;

    if(lastval != 0) {
 	newvalue = (curvalue - lastval) / (now - lasttime);
	sprintf(name, "%.2f cps", newvalue);

	i = 0;
	XtSetArg(Args[i], XtNstring, name); i++;
	XtSetValues(w, Args, i);
    }
}

XtInputCallbackProc x_gettrafin(snmpidstr) SNMPIDSTR *snmpidstr; {
    char	name[80];
    char	value[40];
    u_long	addr, mask;

    recvsnmp(snmpidstr, s_gettrafin);

    if(snmpidstr->snmp_flags & SNMP_DONE) {
	if(snmpidstr->snmp_timeid)
	    XtRemoveTimeOut(snmpidstr->snmp_timeid);
	t_removesnmp(snmpidstr);
    }
}

XtInputCallbackProc x_gettrafout(snmpidstr) SNMPIDSTR *snmpidstr; {
    char	name[80];
    char	value[40];
    u_long	addr, mask;

    recvsnmp(snmpidstr, s_gettrafout);

    if(snmpidstr->snmp_flags & SNMP_DONE) {
	if(snmpidstr->snmp_timeid)
	    XtRemoveTimeOut(snmpidstr->snmp_timeid);
	t_removesnmp(snmpidstr);
    }
}

void snmp_gettraffic(traffic) TRAFFICINFO *traffic; {
    register IFENTRY	*ifptr;
    register Widget	inw, outw;
    HOSTENTRY	*hptr;
    SNMPIDSTR	*snmpidstr;
    SmpBindType *bindlist;
    char	buffer[80];
    TRAFFICINFO	*traffinfo;

    ifptr = traffic->tri_if;
    inw = traffic->tri_inw;
    outw = traffic->tri_outw;

    hptr = ifptr->if_host;

    /* Setup to get input traffic */
    snmpidstr = newsnmpidstr();
    snmpidstr->snmp_glue = (char *)traffic;

    sprintf(buffer, "1.3.6.1.2.1.2.2.1.10.%d", ifptr->if_index);
    if(sendsnmp(hptr, hptr->hl_community
		, buffer, smpCommandGet, snmpidstr) == -1) {
	free(snmpidstr);
	return;
    }
    snmpidstr->snmp_host = hptr;
    snmpidstr->snmp_id = XtAddInput(snmpidstr->snmp_socket
				    , (XtPointer)XtInputReadMask
				    , (XtInputCallbackProc)x_gettrafin
				    , (XtPointer)snmpidstr);
    snmpidstr->snmp_timeid
	= XtAppAddTimeOut(XtWidgetToApplicationContext(Toplevel)
			  , SNMPQUERYTIMEOUT * 1000
			  , (XtTimerCallbackProc)t_removesnmp
			  , (XtPointer)snmpidstr);
    /*
     * We need to save this so that the freetraffif routine can do
     * and XtRemoveTimeOut on it when we stop the monitoring
     */
    traffic->tri_inid = snmpidstr->snmp_timeid; /* so x.c can remove it  */

    /* Setup to get output traffic */
    snmpidstr = newsnmpidstr();
    snmpidstr->snmp_glue = (char *)traffic;

    sprintf(buffer, "1.3.6.1.2.1.2.2.1.16.%d", ifptr->if_index);
    if(sendsnmp(hptr, hptr->hl_community
		, buffer, smpCommandGet, snmpidstr) == -1) {
	free(snmpidstr);
	return;
    }
    snmpidstr->snmp_host = hptr;
    snmpidstr->snmp_id = XtAddInput(snmpidstr->snmp_socket
				    , (XtPointer)XtInputReadMask
				    , (XtInputCallbackProc)x_gettrafout
				    , (XtPointer)snmpidstr);
    snmpidstr->snmp_timeid
	= XtAppAddTimeOut(XtWidgetToApplicationContext(Toplevel)
			  , SNMPQUERYTIMEOUT * 1000
			  , (XtTimerCallbackProc)t_removesnmp
			  , (XtPointer)snmpidstr);
    /*
     * We need to save this so that the freetraffif routine can do
     * and XtRemoveTimeOut on it when we stop the monitoring
     */
    traffic->tri_outid = snmpidstr->snmp_timeid; /* so x.c can remove it  */
}
