%{

/* The lexical part of the syntax used in the .xsnmprc file */

/*
 * Richard Johnson		May 6, 1993
 */

#include <ctype.h>
#include <netinet/in.h>

static struct in_addr	inaddr;

%}

host				[Hh][Oo][Ss][Tt]
mask				[Mm][Aa][Ss][Kk]
interval			[Ii][Nn][Tt][Ee][Rr][Vv][Aa][Ll]
community			[Cc][Oo][Mm][Mm][Uu][Nn][Ii][Tt][Yy]
loc				[Ll][Oo][Cc]
showname			[Ss][Hh][Oo][Ww][Nn][Aa][Mm][Ee]
display				[Dd][Ii][Ss][Pp][Ll][Aa][Yy]

interface			[Ii][Nn][Tt][Ee][Rr][Ff][Aa][Cc][Ee]
ipaddr				[Ii][Pp][Aa][Dd][Dd][Rr]

net				[Nn][Ee][Tt]
name				[Nn][Aa][Mm][Ee]
type				[Tt][Yy][Pp][Ee]
circle				[Cc][Ii][Rr][Cc][Ll][Ee]
line				[Ll][Ii][Nn][Ee]
startloc			[Ss][Tt][Aa][Rr][Tt][Ll][Oo][Cc]
endloc				[Ee][Nn][Dd][Ll][Oo][Cc]
radius				[Rr][Aa][Dd][Ii][Uu][Ss]
center				[Cc][Ee][Nn][Tt][Ee][Rr]
speed				[Ss][Pp][Ee][Ee][Dd]
hide				[Hh][Ii][Dd][Ee]
show				[Ss][Hh][Oo][Ww]

include				[Ii][Nn][Cc][Ll][Uu][Dd][Ee]

qstring				\"[^"]*\"
hexnumber			0[Xx][0-9a-fA-F]+
integer				[0-9]+
ipaddress			[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+

%%

{qstring}			{yylval.string = &yytext[1];
				yytext[strlen(yytext)-1] = '\0';
				 return(STRING);}
{hexnumber}			{sscanf(&yytext[2], "%x", &yylval.number);
					return(HEXNUMBER);}
{ipaddress}			{yylval.number = inet_addr(yytext);
					return(IPADDRESS);}
{integer}			{yylval.number = atoi(yytext);return(INTEGER);}

{host}				{return(HOST);}
{name}				{return(NAME);}
{mask}				{return(MASK);}
{interval}			{return(INTERVAL);}
{community}			{return(COMMUNITY);}
{loc}				{return(LOC);}
{showname}			{return(SHOWNAME);}
{display}			{return(DISPLAY);}

{interface}			{return(INTERFACE);}
{ipaddr}			{return(IPADDR);}

{net}				{return(NET);}
{type}				{return(TYPE);}
{circle}			{return(CIRCLE);}
{line}				{return(LINE);}
{startloc}			{return(STARTLOC);}
{endloc}			{return(ENDLOC);}
{radius}			{return(RADIUS);}
{center}			{return(CENTER);}
{speed}				{return(SPEED);}
{hide}				{return(HIDE);}
{show}				{return(SHOW);}

{include}			{return(INCLUDE);}

[\n\t ,]			{;}

%%
#define input()		xsnmprcinput()
#define unput(c)	xsnmprcunput(c)
#define output(c)	xsnmprcoutput(c)
